#!/usr/bin/perl
# v1.1
daemonize();
check_pid();
open (PID_FILE,">/tmp/resetter.pid");
print PID_FILE $$;
close PID_FILE;

 $FIFO = '/tmp/.resetter-fifo';
 $ENV{PATH} .= ":/etc";
 while (1) {
  unless (-p $FIFO) {
   unlink $FIFO;
   system('mknod', $FIFO, 'p')
   && die "can't mknod $FIFO: $!";
   }

 open (FIFO, "< $FIFO") || die "can't read $FIFO: $!";

system('/bin/stty -F /dev/ttyS0 2400 raw');
open (SER,">>/dev/ttyUSB0");
system('/bin/stty -F /dev/ttyS0 2400 raw');
while ($n = read FIFO, $line, 64) {
	print SER $line;
#	open(DEBUG,">> /tmp/debug.bin");
	chomp($line);
#	print DEBUG $line;
#	close(DEBUG);
	select(undef,undef,undef,1.0);
}
close SER;
close FIFO;
 }  
unlink("/tmp/resetter.pid");

sub daemonize {
chdir '/'		or die "Can't chdir to /: $!";
open STDIN, '/dev/null' or die "Can't read /dev/null: $!";
open STDOUT, '>/dev/null'
or die "Can't write to /dev/null: $!";
setsid			or die "Can't start a new session: $!";
open STDERR, '>&STDOUT'	or die "Can't dup stdout: $!";

    }  


# check_pid - checks if the PID in /tmp/resetter.pid is correct. If not,
# it removes the PID file
sub check_pid {
 open(PID_FILE,"</tmp/resetter.pid") or $child_pid=0;
 $child_pid=<PID_FILE>;
 close(PID_FILE);
 if ($child_pid==0 || (kill 0,$child_pid)==0 ) {
  unlink("/tmp/resetter.pid");
  }
 }
